package weaver.interfaces.hostar.action;

import com.engine.kq.biz.KQFormatBiz;
import com.engine.kq.wfset.util.SplitActionUtil;
import org.apache.commons.lang3.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;

import java.text.SimpleDateFormat;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class OutSignSyncAction implements Action {

    BaseBean bb = new BaseBean();

    @Override
    public String execute(RequestInfo requestInfo) {
        bb.writeLog("OutSignSyncAction-start:" + requestInfo.getRequestid());
        String startDate = "";
        String endDate = "";
        String resourceid = "";
        String nbtxr = "";
        String sjjsrq = "";
        String kssj = "";

        try {

            Property[] properties = requestInfo.getMainTableInfo().getProperty();
            for (Property property : properties) {
                if ("ksrq".equals(property.getName())) {
                    startDate = Util.null2String(property.getValue());
                }
                if ("kssj".equals(property.getName())) {
                    kssj = Util.null2String(property.getValue());
                }
                if ("yjjsrq".equals(property.getName())) {
                    endDate = Util.null2String(property.getValue());
                }
                if ("sjccr".equals(property.getName())) {
                    resourceid = Util.null2String(property.getValue());
                }
                if ("nbtxr".equals(property.getName())) {
                    nbtxr = Util.null2String(property.getValue());
                }
                if ("sjjsrq".equals(property.getName())) {
                    sjjsrq = Util.null2String(property.getValue());
                }
            }

            if (StringUtils.isEmpty(kssj)) {
                return Action.SUCCESS;
            }
            if (kssj.length() < 8) {
                kssj = kssj + ":00";
            }

            // 如果实际结束日期不为空，则用实际结束日期
            if (StringUtils.isNotBlank(sjjsrq)) {
                endDate = sjjsrq;
            }
            bb.writeLog("start to handle data:" + startDate + "、" + endDate + "、" + resourceid);
            if (StringUtils.isNotBlank(startDate) && StringUtils.isNotBlank(endDate) && StringUtils.isNotBlank(resourceid)) {
                // 内部同行人也要考虑
                if (StringUtils.isNotBlank(nbtxr)) {
                    resourceid = resourceid + "," + nbtxr;
                }
                bb.writeLog("OutSignSyncAction resourceid:" + resourceid);
                RecordSet rs = new RecordSet();
                List<String> infos = new ArrayList<>();
                String acqOutSignSql = "select a.id, c.signinfo " +
                        "from mobile_sign a " +
                        "left join uf_outsigntype c " +
                        "on c.outsignid = a.id " +
                        "where operate_date >= '" + startDate + "' and operate_date <= '" + endDate + "' and operater in (" + resourceid + ") ";
                bb.writeLog("OutSignSyncAction acqOutSignSql:" + acqOutSignSql);
                rs.execute(acqOutSignSql);
                while (rs.next()) {
                    String signinfo = Util.null2String(rs.getString("signinfo"));
                    infos.add(signinfo);
                }
                bb.writeLog("infos is:" + infos);

                // 定义时间格式
                DateTimeFormatter formatter = DateTimeFormatter.ofPattern("HH:mm:ss");
                // 解析时间字符串为 LocalTime 对象
                LocalTime oldkssj = LocalTime.parse(kssj, formatter);
                LocalTime minKssj = LocalTime.parse("01:00:00", formatter);

                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

                for (String inf : infos) {
                    if (StringUtils.isNotEmpty(inf)) {
                        Map<String, Object> in = mapStringToMap(inf);
                        String userId = Util.null2String(in.get("userId"));
                        String userType = Util.null2String(in.get("userType"));
                        String signType = Util.null2String(in.get("signType"));
                        String signDate = Util.null2String(in.get("signDate"));
                        String signTime = Util.null2String(in.get("signTime"));
                        String clientAddress = Util.null2String(in.get("clientAddress"));
                        String isInCom = Util.null2String(in.get("isInCom"));
                        String timeZone = Util.null2String(in.get("timeZone"));
                        String belongdate = Util.null2String(in.get("belongdate"));
                        String signfrom = Util.null2String(in.get("signfrom"));
                        String longitude = Util.null2String(in.get("longitude"));
                        String latitude = Util.null2String(in.get("latitude"));
                        String address = Util.null2String(in.get("address"));
                        String deviceInfo = Util.null2String(in.get("deviceInfo"));
                        String belongdateIsNull = Util.null2String(in.get("belongdateIsNull"));

                        if (!oldkssj.isBefore(minKssj)) {
                            // 减去一小时
                            LocalTime previousHour = oldkssj.minusHours(1);
                            LocalTime signTimeLt = LocalTime.parse(signTime, formatter);
                            if (signTimeLt.isBefore(previousHour)) {
                                continue;
                            }
                        }

                        String punchSql = "insert into HrmScheduleSign(userId,userType,signType,signDate,signTime,clientAddress,isInCom,timeZone,belongdate,signfrom,longitude,latitude,addr,deviceInfo,isdev) " +
                                " values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
                        boolean isok = rs.executeUpdate(punchSql, userId, userType, signType, signDate, signTime, clientAddress, isInCom,
                                timeZone, belongdate, signfrom, longitude, latitude, address, deviceInfo, "1");
                        bb.writeLog("isok: " + isok);
                        //同步更新考勤数据到考勤报表
                        if ("true".equals(belongdateIsNull)) {
                            //外勤签到没有归属日期，遇到跨天班次打卡可能归属前一天，需要格式化前一天考勤
                            bb.writeLog("PunchOutButtonCmd:userId:" + userId + ":belongdate:" + DateUtil.getYesterday());
                            new KQFormatBiz().formatDate(userId, DateUtil.getYesterday());
                        }
                        bb.writeLog("PunchOutButtonCmd:userId:" + userId + ":belongdate:" + (belongdate.length() == 0 ? DateUtil.getCurrentDate() : belongdate));
                        if (belongdate.length() == 0) {
                            //外勤签到没有归属日期，遇到跨天班次打卡可能归属前一天，需要格式化前一天考勤
                            new KQFormatBiz().formatDate(userId, DateUtil.getYesterday());
                        }
//                        new KQFormatBiz().formatDate(userId, (belongdate.length() == 0 ? DateUtil.getCurrentDate() : belongdate));
                        Date date = dateFormat.parse(signDate);
                        Calendar calendar = Calendar.getInstance();
                        calendar.setTime(date);
                        calendar.add(Calendar.DATE, -1); // 减去一天
                        Date previousDay = calendar.getTime();
                        String previousDayString = dateFormat.format(previousDay);
                        new KQFormatBiz().formatDate(userId, signDate);
                        new KQFormatBiz().formatDate(userId, previousDayString);
                        //外勤签到转的考勤 处理加班规则
                        SplitActionUtil.pushOverTimeTasksAll(signDate, signDate, userId);
                        if (belongdate.length() != 0) {
                            new KQFormatBiz().formatDate(userId, belongdate);
                            SplitActionUtil.pushOverTimeTasksAll(belongdate, belongdate, userId);
                        }
                    }

                }
            }
        } catch (Exception e) {
            bb.writeLog("OutSignSyncAction Exception: " + e.getMessage());
            return Action.FAILURE_AND_CONTINUE;
        }

        return Action.SUCCESS;
    }

    public static Map<String, Object> mapStringToMap(String str) {
        str = str.substring(1, str.length() - 1);
        List<String> strs = splitString(str);
        Map<String, Object> map = new HashMap<>();
        for (String string : strs) {
            String[] splits = string.split("=");
            String key = splits[0];
            String value = "";
            if (splits.length > 1) {
                value = splits[1];
            }
            // 去掉头部空格
            String key1 = key.trim();
            String value1 = value.trim();
            map.put(key1, value1);
        }
        return map;
    }

    public static List<String> splitString(String input) {
        List<String> result = new ArrayList<>();
        int braceLevel = 0;
        int startIndex = 0;

        for (int i = 0; i < input.length(); i++) {
            char ch = input.charAt(i);
            if (ch == '{') {
                braceLevel++;
            } else if (ch == '}') {
                braceLevel--;
            } else if (ch == ',' && braceLevel == 0) {
                result.add(input.substring(startIndex, i));
                startIndex = i + 1;
            }
        }

        if (startIndex < input.length()) {
            result.add(input.substring(startIndex));
        }

        return result;
    }
}
